'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = wasMutated;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashCollectionAny = require('lodash/collection/any');

var _lodashCollectionAny2 = _interopRequireDefault(_lodashCollectionAny);

function wasMutated(prevStateRef, prevState, state, isImmutable) {
  var sameParentRef = arguments.length <= 4 || arguments[4] === undefined ? false : arguments[4];
  var path = arguments.length <= 5 || arguments[5] === undefined ? [] : arguments[5];

  if (prevState == null || state == null || isImmutable(prevState)) {
    if (sameParentRef) {
      return { wasMutated: prevState !== state, path: path };
    }

    return { wasMutated: false };
  }

  var sameRef = prevStateRef === state;

  // Gather all keys from prev and after states
  var keys = {};
  Object.keys(prevState).forEach(function (key) {
    keys[key] = true;
  });
  Object.keys(state).forEach(function (key) {
    keys[key] = true;
  });

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(keys)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      var result = wasMutated(prevStateRef[key], prevState[key], state[key], isImmutable, sameRef, path.concat(key));
      if (result.wasMutated) {
        return result;
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator['return']) {
        _iterator['return']();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return { wasMutated: false };
}

module.exports = exports['default'];